package jp.sf.grizzly.hatena.pipeline.valve;

import java.io.BufferedWriter;
import java.io.IOException;

public class ConvertNonParagraphValve extends AbstractHatenaValve
{
	private String pattern = "^\\>\\<.*?|.*?\\>\\<$";

	private boolean tagStartFlg;

	protected String getPattern()
	{
		return pattern;
	}

	protected void writeMatchLine(BufferedWriter writer, String line)
			throws IOException
	{
		String s = line;
		if(s.startsWith("><"))
		{
			s  = s.substring(1);
			tagStartFlg = true;
		}
		if(tagStartFlg && s.endsWith("><"))
		{
			s = s.substring(0,s.length()-1);
			tagStartFlg = false;
		}
		writer.write(s);
		writer.newLine();
	}

	protected void writeUnmatchLine(BufferedWriter writer, String line)
			throws IOException
	{
		if(tagStartFlg)
		{
			writer.write(line);
			writer.newLine();
		}else {
			super.writeUnmatchLine(writer, line);
		}
	}
}
