package jp.sf.grizzly.hatena.pipeline.valve;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import jp.sf.grizzly.pipeline.GrizzlyPipeline;
import jp.sf.grizzly.pipeline.PipelineException;
import jp.sf.grizzly.storage.StreamStorage;
import jp.sf.grizzly.storage.StreamStorageException;
import jp.sf.grizzly.storage.impl.FileStreamStorageImpl;
import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ConvertTableValveTest extends TestCase
{
	/**
	 * Logger for this class
	 */
	private static final Log log = LogFactory
			.getLog(ConvertTableValveTest.class);

	GrizzlyPipeline pipeline = null;
	List valveList = new ArrayList();

	public ConvertTableValveTest()
	{
		super();
	}

	public ConvertTableValveTest(String arg0)
	{
		super(arg0);
	}

	protected void setUp() throws Exception
	{
		valveList.add(new ConvertTableValve());
	}

	/**
	 * Rigourous Test :-)
	 */
	public void testInvoke()
	{
		StringBuffer buffer = new StringBuffer();
		try
		{
			pipeline = new GrizzlyPipeline("",valveList);
			StreamStorage storage = new FileStreamStorageImpl(
					new ByteArrayInputStream("|*m1|*m2|*m3|\n|1-1|1-2|1-3|\n|2-1|2-2|2-3|".getBytes("UTF-8")),
					"UTF-8");
			pipeline.invoke(storage);

			BufferedReader r = null;
			try
			{
				r = new BufferedReader(new InputStreamReader(storage
						.getResultInputStream(), storage.getEncoding()));
				String l = null;
				while ((l = r.readLine()) != null)
				{
					buffer.append(l);
				}
			}
			catch (UnsupportedEncodingException e)
			{
				log.warn("Unsupported Encoding. ", e);
			}
			catch (StreamStorageException e)
			{
				log.warn("Stream Storage Exception. ", e);
			}
			catch (IOException e)
			{
				log.error("I/O Exception. ", e);
			}
			finally
			{
				if(r != null)
				{
					try
					{
						r.close();
					}
					catch (IOException e)
					{
					}
				}
			}
			storage.destroy();
		}
		catch (StreamStorageException e)
		{
			log.error("StreamStorage Exception.", e);
		}
		catch (PipelineException e)
		{
			log.error("Pipeline Exception.", e);
		}
		catch (Exception e)
		{
			log.error("Exception.", e);
		}

		assertEquals("<table><tr><th>m1</th><th>m2</th><th>m3</th></tr><tr><td>1-1</td><td>1-2</td><td>1-3</td></tr><tr><td>2-1</td><td>2-2</td><td>2-3</td></tr></table>",buffer.toString());
	}

}
